import numpy as np
import matplotlib.pyplot as plt

if __name__=="__main__":
  N = 1000000
  sourceSizes = [0.001, 0.01, 0.1, 1, 10]
  screenSize = 10
  distance=1
  yyy=[]; zzz=[]

  for sourceSize in sourceSizes:
    yy=[]; zz=[]
    for i in range(N):
      y, z=np.random.uniform(-sourceSize/2, sourceSize/2, 2)
      # theta[-pi, pi] & phi[-pi, pi] 에 대한 Uniform 한 분포는 극 표면에 더 밀집된 분포가 형성된다.
      # 가우시안 분포에서 추출된 x, y, z에 대해서 1/(sqrt(x**2+y**2+z**2))*vector(x, y, z)는 구위에서 균등한 분포를 형성한다고 알려져 있다.
      kx, ky, kz=np.random.normal(0.0, 1.0, 3)
      size=np.sqrt(kx**2+ky**2+kz**2)
      if(kx<=0): continue
      tar_y=y+(distance/kx)*ky
      tar_z=z+(distance/kx)*kz
      if(tar_y>=-screenSize/2 and tar_y<=screenSize/2 and tar_z>=-screenSize/2 and tar_z<=screenSize/2):
        yy.append(tar_y); zz.append(tar_z)
    assert(len(yy)==len(zz))
    yyy.append(yy); zzz.append(zz)

  plt.figure(figsize=(25, 5))
  for i in range(len(sourceSizes)):
    ax=plt.subplot(1, 5, i+1)
    plt.hist2d(yyy[i], zzz[i], bins=100, cmap='gray', range=((-5, 5), (-5, 5)))
    ax.set_title("[source: %d mm]" %(sourceSizes[i]*1000))

  plt.show()
  print("\n", end="", flush=True)

  for i in range(len(sourceSizes)):
    plt.hist(yyy[i], bins=100, alpha=0.2)
  
  plt.show()
